/** @file CaoProvFile.cpp
 *
 *  @brief CCaoProvFile ̎
 *
 *  @version	1.0
 *	@date		2003/8/8
 *	@author		DENSO WAVE
 *
 */

#include "stdafx.h"
#include "CAOPROV.h"
#include "CaoProvController.h"
#include "CaoProvFile.h"


/**	
 *
 *@CaoProvFileIuWFNg쐬čŏɌĂ΂֐łD
 *
 *	@param	pObj	:	[in] eIuWFNg
 *	@retval	HRESULT
 *
 */ 

HRESULT CCaoProvFile::FinalInitialize(PVOID pObj)
{
	CCaoProvController* pCaopCtrl = NULL;
	CCaoProvFile* pCaopFile = NULL;


	// eIuWFNg̔
	switch (m_ulParentType) {
	case SYS_CLS_CONTROLLER:
		// JǗNXւ̃|C^擾
		pCaopCtrl = (CCaoProvController*)pObj;
		m_cameraManager = pCaopCtrl->getCameraManager();
		break;
	case SYS_CLS_FILE:
		pCaopFile = (CCaoProvFile*)pObj;
		break;
	}

	// CaoProvVariableIuWFNgʂ̏ȂǂsD
	return S_OK; // ̃NXȂ S_OK ɂĉD
}


/**	ŏI
 *
 *@CaoProvFileIuWFNgłƂɂPxĂ΂D
 *
 */ 
void CCaoProvFile::FinalTerminate()
{
	// CaoProvFileIuWFNg̉OD
}


/**	t@C̕
 *
 *@ICaoFile::Copy()\bh̎̂ƂȂD
 *
 *	@param	bstrName	:	[in] ʐpXiʐt@Cjij
 *	@param	bstrOption	:	[in] IvV
 *	@retval	HRESULT
 *
 */ 
/*
HRESULT CCaoProvFile::FinalCopy(BSTR bstrName, BSTR bstrOption)
{
	// t@C̕ʂD
	return E_NOTIMPL;
}
*/

/**	t@C̈ړ
 *
 *	@param	bstrName	:	[in] ړt@Cij
 *	@param	bstrOption	:	[in] IvV
 *	@retval	HRESULT
 *
 */
/*
HRESULT CCaoProvFile::FinalMove(BSTR bstrName, BSTR bstrOption)
{
	// t@C̈ړD
	// ICaoFile::Path()vpeB̒lύXĂD
	return E_NOTIMPL;
}
*/

/**	t@C̍폜
 *
 *@ICaoFile::Delete()\bh̎̂ƂȂD
 *
 *	@param	bstrOption	:	[in] IvV
 *	@retval	HRESULT
 *
 */ 
/*
HRESULT CCaoProvFile::FinalDelete(BSTR bstrOption)
{
	// t@C̍폜D
	// CaoProvFileIuWFNg͎cĂD
	return E_NOTIMPL;
}
*/
 
/**	^XN̐
 *
 *@^XN𐶐C^XN擾D
 *
 *	@param	bstrOption	:	[in] IvV
 *	@param	pVal	:	[out] ^XN
 *	@retval	HRESULT
 *
 */  
/*
HRESULT CCaoProvFile::FinalRun(BSTR bstrOption, BSTR *pVal)
{
	// vOs^XN𐶐D
	return E_NOTIMPL;
}
*/

/**	gR}h̎s
 *
 *	@param	Command	:	[in] R}h
 *	@param	pVal	:	[out] s
 *	@retval	HRESULT
 *
 */
/*
HRESULT CCaoProvFile::FinalExecute(VARIANT Command, VARIANT *pVal)
{
	// eЃR}h߁CsCsʂԂD
	// sʂ́CeЖɁiVARIANTŁjRłD
	return E_NOTIMPL;
}
*/

/**	t@C̎擾
 *
 *@ICaoFile::Attribute()vpeB̎̂ƂȂD
 *
 *	@param	pVal	:	[out] t@C
 *	@retval	HRESULT
 *
 */
/*
HRESULT CCaoProvFile::FinalGetAttribute(long *pVal)
{
    // t@C̑ LONG^ Ŏ擾D
	return E_NOTIMPL;
}
*/

/**	t@C쐬̎擾
 *
 *@ICaoFile::DateCreated()vpeB̎̂ƂȂD
 *
 *	@param	pVal	:	[out] t@C쐬
 *	@retval	HRESULT
 *
 */
/*
HRESULT CCaoProvFile::FinalGetDateCreated(VARIANT *pVal)
{
    // VARIANT(pVal->vt = VT_DATECpVal->date = xxx)ɎԂi[D
	return E_NOTIMPL;
}
*/
  
/**	tH_ŏIANZX̎擾
 *
 *@ICaoFile::DateLastAccessed()vpeB̎̂ƂȂD
 *
 *	@param	pVal	:	[out] t@CŏIANZX
 *	@retval	HRESULT
 *
 */
/*
HRESULT CCaoProvFile::FinalGetDateLastAccessed(VARIANT *pVal)
{
    // VARIANT(pVal->vt = VT_DATECpVal->date = xxx)ɎԂi[D
	return E_NOTIMPL;
}
*/

/**	t@CXV擾
 *
 *@ICaoFile::DateLastModified()vpeB̎̂ƂȂD
 *
 *	@param	pVal	:	[out] t@CXV
 *	@retval	HRESULT
 *
 */
/*
HRESULT CCaoProvFile::FinalGetDateLastModified(VARIANT *pVal)
{
    // VARIANT(pVal->vt = VT_DATECpVal->date = xxx)ɎԂi[D
	return E_NOTIMPL;
}
*/

/**	wv̎擾
 *
 *@Rgi[ĂD
 *@ICaoFile::Help()vpeB̎̂ƂȂD
 *
 *	@param	pVal	:	[out] wv
 *	@retval	HRESULT
 *
 */
/*
HRESULT CCaoProvFile::FinalGetHelp(BSTR *pVal)
{
	// Cӂ̃wvԂD
	return E_NOTIMPL;
}
*/

/**	pX̎擾
 *
 *@t@C̃tpX擾D
 *@ICaoFile::Path()vpeB̎̂ƂȂD
 *
 *	@param	pVal	:	[out] t@C̃tpXij
 *	@retval	HRESULT
 *
 */
/*
HRESULT CCaoProvFile::FinalGetPath(BSTR *pVal)
{
	// t@C̃tpX擾D
	return E_NOTIMPL;
}
*/

/**	TCY̎擾
 *
 *@ICaoFile::Size()vpeB̎̂ƂȂD
 *
 *	@param	pVal	:	[out] TCYioCgj
 *	@retval	HRESULT
 *
 */
/*
HRESULT CCaoProvFile::FinalGetSize(long *pVal)
{
	// TutH_܂ރoCgTCY擾D
	return E_NOTIMPL;
}
*/

/**	^Cvigqj̎擾
 *
 *@^Cvigqj𕶎Ŏ擾D
 *@ICaoFile::Type()vpeB̎̂ƂȂD
 *
 *	@param	pVal	:	[out] ^Cvigqjf[^
 *	@retval	HRESULT
 *
 */
/*
HRESULT CCaoProvFile::FinalGetType(BSTR *pVal)
{
	// gq𕶎ŕԂD
	return E_NOTIMPL;
}
*/

/**	t@C̓e̎擾
 *
 *	@param	pVal	:	[in] t@Ce
 *	@retval	HRESULT
 *
 */
HRESULT CCaoProvFile::FinalGetValue(VARIANT *pVal)
{
	long lSize;

	// JǗNX摜f[^擾D
	BYTE *buf = m_cameraManager->GetImage(&lSize);
	SAFEARRAY* pSa;
	SAFEARRAYBOUND bounds = {lSize , 0}; // Elemnts, LBound

	// BYTE^SAFEARRAYpӂ摜f[^Rs[
	pSa = SafeArrayCreate(VT_UI1, 1, &bounds);
	BYTE* pbstrArray;
	SafeArrayAccessData(pSa, (void **)&pbstrArray);
	for (long i= 0; i < lSize; i++) {
		pbstrArray[i] = *buf;
		buf++;
	}
	SafeArrayUnaccessData(pSa);
	pVal->vt = VT_ARRAY | VT_UI1;
	pVal->parray = pSa;
//	free(buf);

	return S_OK;
}


/**	t@C̓e̐ݒ
 *
 *	@param	newVal	:	[in] t@Ce
 *	@retval	HRESULT
 *
 */
/*
HRESULT CCaoProvFile::FinalPutValue(VARIANT newVal)
{
	// eLXgf[^iVT_BSTRjoCif[^iVT_UI1|VT_ARRAYj𔻕
	if (newVal.vt == VT_BSTR) {		// eLXgf[^
		// f[^̓]
	} else {						// oCif[^
		// 󂯎p[^Qƌ^mF
		SAFEARRAY* pSa;
		if (newVal.vt & VT_BYREF) {
			pSa = *(newVal.pparray);
		} else {
			pSa = newVal.parray;
		}
		// f[^̓]
	}

	return E_NOTIMPL;
}
*/

/**	t@CXg̎擾
 *
 *	@param	bstrOption	:	[in] IvV
 *	@param	pVal	:	[out] t@CXg
 *	@retval	HRESULT
 *
 */
/*
HRESULT CCaoProvFile::FinalGetFileNames(BSTR bstrOption, VARIANT *pVal)
{
	// t@CXg𕶎SAFEARRAYƂč쐬D
    // ̃|C^VARIANT(pVal->vt = VT_BSTR|VT_ARRAYCpVal->parray = xxx)Ɋi[D
	return E_NOTIMPL;
}
*/

/**	ϐXg̎擾
 *
 *	@param	bstrOption	:	[in] IvV
 *	@param	pVal	:	[out] ϐXg
 *	@retval	HRESULT
 *
 */
/*
HRESULT CCaoProvFile::FinalGetVariableNames(BSTR bstrOption, VARIANT *pVal)
{
	// ϐXg𕶎SAFEARRAYƂč쐬D
    // ̃|C^VARIANT(pVal->vt = VT_BSTR|VT_ARRAYCpVal->parray = xxx)Ɋi[D
	return E_NOTIMPL;
}
*/

/**	ID̎擾
 *
 *	@param	pVal	:	[out] ID
 *	@retval	HRESULT
 *
 */
/*
HRESULT CCaoProvFile::FinalGetID(VARIANT *pVal)
{
	return E_NOTIMPL;
}
*/

/**	ID̐ݒ
 *
 *	@param	newVal	:	[in] ID
 *	@retval	HRESULT
 *
 */
/*
HRESULT CCaoProvFile::FinalPutID(VARIANT newVal)
{
	return E_NOTIMPL;
}
*/

// ========== eВǉ֐͂ȉɋLqD==========
