/** @file CaoProvVariable.cpp
 *
 *  @brief CCaoProvVariable ̎
 *
 *  @version	1.0
 *	@date		2003/8/8
 *	@author		DENSO WAVE
 *
 */

#include "stdafx.h"
#include "CAOPROV.h"
#include "CaoProvController.h"
#include "CaoProvVariable.h"

/**	
 *
 *@CaoProvVariableIuWFNg쐬čŏɌĂ΂֐łD
 *
 *	@param	pObj	:	[in] eIuWFNg
 *	@retval	HRESULT
 *
 */ 
HRESULT CCaoProvVariable::FinalInitialize(PVOID pObj)
{
	CCaoProvController* pCaopCtrl = NULL;
	CCaoProvExtension* pCaopExp = NULL;
	CCaoProvFile* pCaopFile = NULL;
	CCaoProvRobot* pCaopRobot = NULL;
	CCaoProvTask* pCaopTask = NULL;

	// eIuWFNg̔
	switch (m_ulParentType) {
	case SYS_CLS_CONTROLLER:
		// JǗNXւ̃|C^擾
		pCaopCtrl = (CCaoProvController*)pObj;
		m_cameraManager = pCaopCtrl->getCameraManager();
		break;
	case SYS_CLS_EXTENSION:
		pCaopExp = (CCaoProvExtension*)pObj;
		break;
	case SYS_CLS_FILE:
		pCaopFile = (CCaoProvFile*)pObj;
		break;
	case SYS_CLS_ROBOT:
		pCaopRobot = (CCaoProvRobot*)pObj;
		break;
	case SYS_CLS_TASK:
		pCaopTask = (CCaoProvTask*)pObj;
		break;
	}

	// CaoProvVariableIuWFNgʂ̏ȂǂsD
	return S_OK; // ̃NXȂ S_OK ɂĉD
}

/**	ŏI
 *
 *@CaoProvVariableIuWFNgłƂɂPxĂ΂D
 *
 */ 
void CCaoProvVariable::FinalTerminate()
{
	// CaoProvVariableIuWFNg̉OD
}

/**	̎擾
 *
 *@ICaoVariable::Attribute()vpeB̎̂ƂȂD
 *
 *	@param	pVal	:	[out] 
 *	@retval	HRESULT
 *
 */
/*
HRESULT CCaoProvVariable::FinalGetAttribute(long *pVal)
{
	// ϐ̑擾D
	return E_NOTIMPL;
}
*/

/**	wv̎擾
 *
 *@Rgi[ĂD
 *@ICaoVariable::Help()vpeB̎̂ƂȂD
 *
 *	@param	pVal	:	[out] wv
 *	@retval	HRESULT
 *
 */
/*
HRESULT CCaoProvVariable::FinalGetHelp(BSTR *pVal)
{
	// Cӂ̃wvԂD
	return E_NOTIMPL;
}
*/

/**	l̃^CX^v̎擾
 *
 *@ICaoVariable::DateTime()vpeB̎̂ƂȂD
 *
 *	@param	pVal	:	[out]  f[^
 *	@retval	HRESULT
 *
 */  
/*
HRESULT CCaoProvVariable::FinalGetDateTime(VARIANT *pVal)
{
	// Rg[̕ϐɃANZXԂ擾D
	// ftHĝ܂܂ł΁Cm_vntDateTimel擾D
	return E_NOTIMPL;
}
*/

/**	ϐ̒l̎擾
 *
 *@ICaoVariable::get_Value()̎̂ƂȂD
 *
 *	@param	pVal	:	[in]  ϐl
 *	@retval	HRESULT
 *
 */  
HRESULT CCaoProvVariable::FinalGetValue(VARIANT *pVal)
{
	// JǗNX犴x擾߂lƂ
	pVal->vt = VT_I4;
	pVal->lVal = m_cameraManager->GetThreshold();
	return S_OK;
}

/**	ϐ̒l̕ύX
 *
 *@ICaoVariable::put_Value()̎̂ƂȂD
 *
 *	@param	newVal	:	[in]  ϐl
 *	@retval	HRESULT
 *
 */  
HRESULT CCaoProvVariable::FinalPutValue(VARIANT newVal)
{
	// JǗNXɊxݒ肷
	if( newVal.vt == VT_I4 ){
		m_cameraManager->SetThreshold( newVal.lVal );
		return S_OK;
	} else {
		return S_FALSE;
	}
}

/**	ID̎擾
 *
 *	@param	pVal	:	[out] ID
 *	@retval	HRESULT
 *
 */
/*
HRESULT CCaoProvVariable::FinalGetID(VARIANT *pVal)
{
	return E_NOTIMPL;
}
*/

/**	ID̐ݒ
 *
 *	@param	newVal	:	[in] ID
 *	@retval	HRESULT
 *
 */
/*
HRESULT CCaoProvVariable::FinalPutID(VARIANT newVal)
{
	return E_NOTIMPL;
}
*/

/**	}CNb̃^CX^v̎擾
 *
 *	@param	pVal	:	[out] ID
 *	@retval	HRESULT
 *
 */
/*
HRESULT CCaoProvVariable::FinalGetMicrosecond(long *pVal)
{
	return E_NOTIMPL;
}
*/

// ========== eВǉ֐͂ȉɋLqD==========
