/** @file CaoProvController.cpp
 *
 *  @brief CCaoProvController ̎
 *
 *  @version	1.0
 *	@date		2003/8/8
 *	@author		DENSO WAVE
 *
 */

#include "stdafx.h"
#include "CAOPROV.h"
#include "CaoProvController.h"

/**	
 *
 *@CaoProvControllerIuWFNg쐬čŏɌĂ΂֐łD
 *
 *	@retval	HRESULT
 *
 */ 
HRESULT CCaoProvController::FinalInitialize(){
    HRESULT hr;
    hr = m_mouseManager.Initialize();
    if (FAILED(hr)) {
        return FALSE;
    }
    return S_OK;
}



/**	ŏI
 *
 *@CaoProvControllerIuWFNgłƂɂPxĂ΂D
 *
 *	@retval	HRESULT
 *
 */ 
void CCaoProvController::FinalTerminate(){
    m_mouseManager.Finalize();
}


/**	voC_ڑJn
 *
 *@voC_ōŏɌĂ΂֐łD
 *
 *	@retval	HRESULT
 *
 */
HRESULT CCaoProvController::FinalDisconnect(){
    return S_OK;
}


/**	voC_ؒf
 *
 *	@retval	HRESULT
 *
 */
HRESULT CCaoProvController::FinalConnect(){
    return S_OK;
}


/**	gR}h̎s
 *
 *	@param	Command	:	[in] R}h
 *	@param	pVal	:	[out] s
 *	@retval	HRESULT
 *
 */
/*
HRESULT CCaoProvController::FinalExecute(VARIANT Command, VARIANT *pVal)
{
	// eЃR}h߁CsCsʂԂD
	// sʂ́CeЖɁiVARIANTŁjRłD
	return E_NOTIMPL; 
}
*/

/**	̎擾
 *
 *	@param	pVal	:	[out] 
 *	@retval	HRESULT
 *
 */ 
/*
HRESULT CCaoProvController::FinalGetAttribute(long *pVal)
{
    // Rg[̑ LONG^ Ŏ擾D
	return E_NOTIMPL; 
}
*/

/**	wv̎擾
 *
 *	@param	pVal	:	[out] wv
 *	@retval	HRESULT
 *
 */ 
/*
HRESULT CCaoProvController::FinalGetHelp(BSTR *pVal)
{
	// Cӂ̃wvԂD
	return E_NOTIMPL;
}
*/

/**	R}hXg̎擾
 *
 *	@param	bstrOption	:	[in] IvV
 *	@param	pVal	:	[out] ϐXg
 *	@retval	HRESULT
 *
 */ 
/*
HRESULT CCaoProvController::FinalGetCommandNames(BSTR bstrOption, VARIANT *pVal)
{
	// ϐXg𕶎SAFEARRAYƂč쐬D
    // ̃|C^VARIANT(pVal->vt = VT_BSTR|VT_ARRAYCpVal->parray = xxx)Ɋi[D
	return E_NOTIMPL;
}
*/

/**	g{[hXg̎擾
 *
 *	@param	bstrOption	:	[in] IvV
 *	@param	pVal	:	[out] g{[hXg
 *	@retval	HRESULT
 *
 */ 
/*
HRESULT CCaoProvController::FinalGetExtensionNames(BSTR bstrOption, VARIANT *pVal)
{
	// g{[hXg𕶎SAFEARRAYƂč쐬D
    // ̃|C^VARIANT(pVal->vt = VT_BSTR|VT_ARRAYCpVal->parray = xxx)Ɋi[D
	return E_NOTIMPL;
}
*/

/**	t@CXg̎擾
 *
 *	@param	bstrOption	:	[in] IvV
 *	@param	pVal	:	[out] t@CXg
 *	@retval	HRESULT
 *
 */ 
/*
HRESULT CCaoProvController::FinalGetFileNames(BSTR bstrOption, VARIANT *pVal)
{
	// t@CXg𕶎SAFEARRAYƂč쐬D
    // ̃|C^VARIANT(pVal->vt = VT_BSTR|VT_ARRAYCpVal->parray = xxx)Ɋi[D
	return E_NOTIMPL;
}
*/

/**	{bgXg̎擾
 *
 *	@param	bstrOption	:	[in] IvV
 *	@param	pVal	:	[out] {bgXg
 *	@retval	HRESULT
 *
 */ 
/*
HRESULT CCaoProvController::FinalGetRobotNames(BSTR bstrOption, VARIANT *pVal)
{
	// {bgXg𕶎SAFEARRAYƂč쐬D
    // ̃|C^VARIANT(pVal->vt = VT_BSTR|VT_ARRAYCpVal->parray = xxx)Ɋi[D
	return E_NOTIMPL; 
}
*/

/**	^XNXg̎擾
 *
 *	@param	bstrOption	:	[in] IvV
 *	@param	pVal	:	[out] ^XNXg
 *	@retval	HRESULT
 *
 */ 
/*
HRESULT CCaoProvController::FinalGetTaskNames(BSTR bstrOption, VARIANT *pVal)
{
	// ^XNXg𕶎SAFEARRAYƂč쐬D
    // ̃|C^VARIANT(pVal->vt = VT_BSTR|VT_ARRAYCpVal->parray = xxx)Ɋi[D
	return E_NOTIMPL;
}
*/

/**	ϐXg̎擾
 *
 *	@param	bstrOption	:	[in] IvV
 *	@param	pVal	:	[out] ϐXg
 *	@retval	HRESULT
 *
 */ 
/*
HRESULT CCaoProvController::FinalGetVariableNames(BSTR bstrOption, VARIANT *pVal)
{
	// ϐXg𕶎SAFEARRAYƂč쐬D
    // ̃|C^VARIANT(pVal->vt = VT_BSTR|VT_ARRAYCpVal->parray = xxx)Ɋi[D
	return E_NOTIMPL;
}
*/

/**	ID̎擾
 *
 *	@param	pVal	:	[out] ID
 *	@retval	HRESULT
 *
 */
/*
HRESULT CCaoProvController::FinalGetID(VARIANT *pVal)
{
	return E_NOTIMPL;
}
*/

/**	ID̐ݒ
 *
 *	@param	newVal	:	[in] ID
 *	@retval	HRESULT
 *
 */
/*
HRESULT CCaoProvController::FinalPutID(VARIANT newVal)
{
	return E_NOTIMPL;
}
*/

#if CAOP_TIMER_INTERVAL > 0 
/**	^C}[Cxg
 *
 * #define CAOP_TIMER_INTERVAL 0  ` msPʎwŒ`D
 * ɂ CAOP_TIMER_INTERVAL msԊuł̊֐Ă΂D
 *
 */
void CCaoProvController::OnTimer(){
    HRESULT hr;
    VARIANT vData;
    CComPtr<CCaoProvMessage> pMess;

    // }EXʒul
    m_mouseManager.GetLocation(&vData);

    // bZ[W𐶐^M
    hr = CreateMessage(&pMess, -1, &vData);
    if (SUCCEEDED(hr)) {
        SendMessage(pMess, CAO_MSG_NORMAL);
    }
	return;
}
#endif


// ========== eВǉ֐͂ȉɋLqD==========
