/** @file CameraManager.h
 *
 *  @brief CCameraManager ̐錾
 *
 *  @version    1.0
 *  @date       2005/5/23
 *  @author     SEC
 *
 */

#ifndef __CAMERAMANAGER_H_
#define __CAMERAMANAGER_H_

#include "stdafx.h"
#include <dshow.h>
#include <qedit.h>
#include <conio.h>
#include <math.h>

/** J}l[WNX
 *
 *  USBJǗNXB
 *
 */
class CCameraManager  
{
public:
	CCameraManager();
	virtual ~CCameraManager();
    HRESULT Initialize();
    void Finalize();
    HRESULT Capture();
    BOOL IsDiffDetected();
	BYTE *GetImage(long *lSize);
	long GetThreshold();
	void SetThreshold( long threshold );
private:
    IPin* GetPin(IBaseFilter *pFilter, PIN_DIRECTION PinDir);

private:
    IGraphBuilder *m_pGraph;           // tB^Ot}l[W
    IMediaControl *m_pMC;              // fBARg[
    IMediaEvent *m_pEV;                // fBACxg
    ICaptureGraphBuilder2 *m_pCapture; // Lv`Ot
    IBaseFilter *m_pF;                 // OotB^
    IBaseFilter *m_pbf;                // foCXtB^
    IBaseFilter *m_pNull;              // Null_tB^
    ISampleGrabber *m_pGrab;           // TvOo
    BYTE *m_pBuffer_Cur;                   // 摜i[obt@(Jg)
    BYTE *m_pBuffer_Pre;                   // 摜i[obt@(v)
	BYTE *m_pImage;						// 摜f[^(rbg}bv`)
    long m_imageSize;					// 摜TCY
    BOOL m_bInitialize;					// tO
	long m_threshold;                   // 摜ω臒l
    HANDLE m_hMutex;					// Mutex
};

#endif // __CAMERAMANAGER_H_
